/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.reflective.preview;

import org.eclipse.emf.common.ui.ViewerPane;
import org.eclipse.swt.widgets.Composite;

import fr.obeo.acceleo.gen.ui.editors.reflective.AcceleoReflectiveEditor;

/**
 * A loader to create a request view on the reflective editor.
 * 
 * @author www.obeo.fr
 * 
 */
public interface IRequestLoader {

	/**
	 * Creates a request view on the reflective editor.
	 * 
	 * @param editor
	 *            is the editor
	 * @param container
	 *            is the composite
	 * @return the request viewer
	 */
	public ViewerPane createRequestPane(AcceleoReflectiveEditor editor, Composite container);

}
