/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.gen.profiler.provider;

import fr.obeo.acceleo.gen.profiler.LoopProfileEntry;
import fr.obeo.acceleo.gen.profiler.ProfilerFactory;
import fr.obeo.acceleo.gen.profiler.ProfileEntry;
import fr.obeo.acceleo.gen.profiler.ProfilerPackage;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Collection;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a
 * {@link fr.obeo.acceleo.gen.profiler.LoopProfileEntry} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class LoopProfileEntryItemProvider extends ProfileEntryItemProvider implements IEditingDomainItemProvider, IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public LoopProfileEntryItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ProfilerPackage.Literals.LOOP_PROFILE_ENTRY__LOOP_ELEMENTS);
		}
		return childrenFeatures;
	}

	/**
	 * This returns LoopProfileEntry.gif. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Object getImage(Object object) {
		final int spacePos = ((ProfileEntry) object).getMonitored().indexOf(" ");
		String name = ""; //$NON-NLS-1$
		if (spacePos > -1) {
			name = "full/obj16/" + ((ProfileEntry) object).getMonitored().substring(0, spacePos); //$NON-NLS-1$
		}
		try {
			return overlayImage(object, getResourceLocator().getImage(name));
		} catch (final MissingResourceException e) {
			return overlayImage(object, getResourceLocator().getImage("full/obj16/LoopProfileEntry"));
		}
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String getText(Object object) {
		final LoopProfileEntry loopProfileEntry = (LoopProfileEntry) object;
		final NumberFormat format = new DecimalFormat();
		format.setMaximumIntegerDigits(3);
		format.setMaximumFractionDigits(2);
		return format.format(loopProfileEntry.getPercentage()) + "% / " + loopProfileEntry.getDuration() + "ms / " + loopProfileEntry.getCount() + " times [" + loopProfileEntry.getMonitored() + "]";
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(LoopProfileEntry.class)) {
			case ProfilerPackage.LOOP_PROFILE_ENTRY__LOOP_ELEMENTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(ProfilerPackage.Literals.LOOP_PROFILE_ENTRY__LOOP_ELEMENTS,
				 ProfilerFactory.eINSTANCE.createProfileEntry()));

		newChildDescriptors.add
			(createChildParameter
				(ProfilerPackage.Literals.LOOP_PROFILE_ENTRY__LOOP_ELEMENTS,
				 ProfilerFactory.eINSTANCE.createLoopProfileEntry()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getCreateChildText(Object owner, Object feature, Object child, Collection selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == ProfilerPackage.Literals.PROFILE_ENTRY__CALLEES ||
			childFeature == ProfilerPackage.Literals.LOOP_PROFILE_ENTRY__LOOP_ELEMENTS;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	/**
	 * Return the resource locator for this item provider's resources. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return ProfilerEditPlugin.INSTANCE;
	}

}
