/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.template.core.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import fr.obeo.acceleo.template.core.CoreFactory;
import fr.obeo.acceleo.template.core.CorePackage;
import fr.obeo.acceleo.template.core.ScriptDescriptor;
import fr.obeo.acceleo.template.expressions.ExpressionsFactory;
import fr.obeo.acceleo.template.provider.TemplateEditPlugin;

/**
 * This is the item provider adapter for a
 * {@link fr.obeo.acceleo.template.core.ScriptDescriptor} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class ScriptDescriptorItemProvider extends ItemProviderAdapter implements IEditingDomainItemProvider, IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ScriptDescriptorItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addTypePropertyDescriptor(object);
			addDescriptionPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ScriptDescriptor_name_feature"), getString("_UI_PropertyDescriptor_description", "_UI_ScriptDescriptor_name_feature", "_UI_ScriptDescriptor_type"),
				CorePackage.Literals.SCRIPT_DESCRIPTOR__NAME, true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Type feature. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ScriptDescriptor_type_feature"), getString("_UI_PropertyDescriptor_description", "_UI_ScriptDescriptor_type_feature", "_UI_ScriptDescriptor_type"),
				CorePackage.Literals.SCRIPT_DESCRIPTOR__TYPE, true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This adds a property descriptor for the Description feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addDescriptionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add(createItemPropertyDescriptor(((ComposeableAdapterFactory) adapterFactory).getRootAdapterFactory(), getResourceLocator(),
				getString("_UI_ScriptDescriptor_description_feature"), getString("_UI_PropertyDescriptor_description", "_UI_ScriptDescriptor_description_feature", "_UI_ScriptDescriptor_type"),
				CorePackage.Literals.SCRIPT_DESCRIPTOR__DESCRIPTION, true, false, false, ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to
	 * deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand},
	 * {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in
	 * {@link #createCommand}. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CorePackage.Literals.SCRIPT_DESCRIPTOR__FILE);
			childrenFeatures.add(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper
		// feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns ScriptDescriptor.gif. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/ScriptDescriptor"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((ScriptDescriptor) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_ScriptDescriptor_type") : getString("_UI_ScriptDescriptor_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to
	 * update any cached children and by creating a viewer notification, which
	 * it passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ScriptDescriptor.class)) {
		case CorePackage.SCRIPT_DESCRIPTOR__NAME:
		case CorePackage.SCRIPT_DESCRIPTOR__TYPE:
		case CorePackage.SCRIPT_DESCRIPTOR__DESCRIPTION:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
			return;
		case CorePackage.SCRIPT_DESCRIPTOR__FILE:
		case CorePackage.SCRIPT_DESCRIPTOR__POST:
			fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
			return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of
	 * {@link org.eclipse.emf.edit.command.CommandParameter}s describing all of
	 * the children that can be created under this object. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__FILE, CoreFactory.eINSTANCE.createFilePath()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createCallSet()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createNot()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createOperator()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createParenthesis()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createStringLiteral()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createIntegerLiteral()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add(createChildParameter(CorePackage.Literals.SCRIPT_DESCRIPTOR__POST, ExpressionsFactory.eINSTANCE.createNullLiteral()));
	}

	/**
	 * Return the resource locator for this item provider's resources. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return TemplateEditPlugin.INSTANCE;
	}

}
