/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.state_machines;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Transition</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getGuard
 * <em>Guard</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getEffect
 * <em>Effect</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getState
 * <em>State</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTrigger
 * <em>Trigger</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getStateMachine
 * <em>State Machine</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getSource
 * <em>Source</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTarget
 * <em>Target</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition()
 * @model
 * @generated
 */
public interface Transition extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Guard</b></em>' containment
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Guard#getTransition
	 * <em>Transition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Guard</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Guard</em>' containment reference.
	 * @see #setGuard(Guard)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_Guard()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Guard#getTransition
	 * @model opposite="transition" containment="true"
	 * @generated
	 */
	Guard getGuard();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getGuard
	 * <em>Guard</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Guard</em>' containment
	 *            reference.
	 * @see #getGuard()
	 * @generated
	 */
	void setGuard(Guard value);

	/**
	 * Returns the value of the '<em><b>Effect</b></em>' containment
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getTransition
	 * <em>Transition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Effect</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Effect</em>' containment reference.
	 * @see #setEffect(Action)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_Effect()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getTransition
	 * @model opposite="transition" containment="true"
	 * @generated
	 */
	Action getEffect();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getEffect
	 * <em>Effect</em>}' containment reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Effect</em>' containment
	 *            reference.
	 * @see #getEffect()
	 * @generated
	 */
	void setEffect(Action value);

	/**
	 * Returns the value of the '<em><b>State</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State#getInternalTransition
	 * <em>Internal Transition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>State</em>' container reference.
	 * @see #setState(State)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_State()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State#getInternalTransition
	 * @model opposite="internalTransition"
	 * @generated
	 */
	State getState();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getState
	 * <em>State</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>State</em>' container reference.
	 * @see #getState()
	 * @generated
	 */
	void setState(State value);

	/**
	 * Returns the value of the '<em><b>Trigger</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Event#getTransition
	 * <em>Transition</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trigger</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Trigger</em>' reference.
	 * @see #setTrigger(Event)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_Trigger()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Event#getTransition
	 * @model opposite="transition"
	 * @generated
	 */
	Event getTrigger();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTrigger
	 * <em>Trigger</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Trigger</em>' reference.
	 * @see #getTrigger()
	 * @generated
	 */
	void setTrigger(Event value);

	/**
	 * Returns the value of the '<em><b>State Machine</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine#getTransitions
	 * <em>Transitions</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State Machine</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>State Machine</em>' container
	 *         reference.
	 * @see #setStateMachine(StateMachine)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_StateMachine()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine#getTransitions
	 * @model opposite="transitions"
	 * @generated
	 */
	StateMachine getStateMachine();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getStateMachine
	 * <em>State Machine</em>}' container reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>State Machine</em>' container
	 *            reference.
	 * @see #getStateMachine()
	 * @generated
	 */
	void setStateMachine(StateMachine value);

	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getOutgoing
	 * <em>Outgoing</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(StateVertex)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_Source()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getOutgoing
	 * @model opposite="outgoing" required="true"
	 * @generated
	 */
	StateVertex getSource();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getSource
	 * <em>Source</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(StateVertex value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getIncoming
	 * <em>Incoming</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(StateVertex)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage#getTransition_Target()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateVertex#getIncoming
	 * @model opposite="incoming" required="true"
	 * @generated
	 */
	StateVertex getTarget();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition#getTarget
	 * <em>Target</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(StateVertex value);

} // Transition
