/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.CallAction;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CallEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Method;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.Operation;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.data_types.CallConcurrencyKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ScopeKind;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Operation</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#getConcurrency
 * <em>Concurrency</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#isIsRoot
 * <em>Is Root</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#isIsLeaf
 * <em>Is Leaf</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#isIsAbstract
 * <em>Is Abstract</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#getSpecification
 * <em>Specification</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#getMethod
 * <em>Method</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#getCallAction
 * <em>Call Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.OperationImpl#getOccurrence
 * <em>Occurrence</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class OperationImpl extends BehavioralFeatureImpl implements Operation {
	/**
	 * The default value of the '{@link #getConcurrency() <em>Concurrency</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getConcurrency()
	 * @generated
	 * @ordered
	 */
	protected static final CallConcurrencyKind CONCURRENCY_EDEFAULT = CallConcurrencyKind.CCK_SEQUENTIAL_LITERAL;

	/**
	 * The cached value of the '{@link #getConcurrency() <em>Concurrency</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getConcurrency()
	 * @generated
	 * @ordered
	 */
	protected CallConcurrencyKind concurrency = CONCURRENCY_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsRoot() <em>Is Root</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsRoot()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ROOT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsRoot() <em>Is Root</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsRoot()
	 * @generated
	 * @ordered
	 */
	protected boolean isRoot = IS_ROOT_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsLeaf() <em>Is Leaf</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsLeaf()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_LEAF_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsLeaf() <em>Is Leaf</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsLeaf()
	 * @generated
	 * @ordered
	 */
	protected boolean isLeaf = IS_LEAF_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsAbstract() <em>Is Abstract</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsAbstract()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_ABSTRACT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsAbstract() <em>Is Abstract</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsAbstract()
	 * @generated
	 * @ordered
	 */
	protected boolean isAbstract = IS_ABSTRACT_EDEFAULT;

	/**
	 * The default value of the '{@link #getSpecification()
	 * <em>Specification</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSpecification()
	 * @generated
	 * @ordered
	 */
	protected static final String SPECIFICATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSpecification()
	 * <em>Specification</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSpecification()
	 * @generated
	 * @ordered
	 */
	protected String specification = SPECIFICATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMethod() <em>Method</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMethod()
	 * @generated
	 * @ordered
	 */
	protected EList method = null;

	/**
	 * The cached value of the '{@link #getCallAction() <em>Call Action</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCallAction()
	 * @generated
	 * @ordered
	 */
	protected EList callAction = null;

	/**
	 * The cached value of the '{@link #getOccurrence() <em>Occurrence</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOccurrence()
	 * @generated
	 * @ordered
	 */
	protected EList occurrence = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected OperationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getOperation();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CallConcurrencyKind getConcurrency() {
		return concurrency;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setConcurrency(CallConcurrencyKind newConcurrency) {
		CallConcurrencyKind oldConcurrency = concurrency;
		concurrency = newConcurrency == null ? CONCURRENCY_EDEFAULT : newConcurrency;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.OPERATION__CONCURRENCY, oldConcurrency, concurrency));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsRoot() {
		return isRoot;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsRoot(boolean newIsRoot) {
		boolean oldIsRoot = isRoot;
		isRoot = newIsRoot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.OPERATION__IS_ROOT, oldIsRoot, isRoot));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsLeaf() {
		return isLeaf;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsLeaf(boolean newIsLeaf) {
		boolean oldIsLeaf = isLeaf;
		isLeaf = newIsLeaf;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.OPERATION__IS_LEAF, oldIsLeaf, isLeaf));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsAbstract() {
		return isAbstract;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsAbstract(boolean newIsAbstract) {
		boolean oldIsAbstract = isAbstract;
		isAbstract = newIsAbstract;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.OPERATION__IS_ABSTRACT, oldIsAbstract, isAbstract));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getSpecification() {
		return specification;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSpecification(String newSpecification) {
		String oldSpecification = specification;
		specification = newSpecification;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.OPERATION__SPECIFICATION, oldSpecification, specification));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMethod() {
		if (method == null) {
			method = new EObjectWithInverseResolvingEList(Method.class, this, CorePackage.OPERATION__METHOD, CorePackage.METHOD__SPECIFICATION);
		}
		return method;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getCallAction() {
		if (callAction == null) {
			callAction = new EObjectWithInverseResolvingEList(CallAction.class, this, CorePackage.OPERATION__CALL_ACTION, Common_behaviorPackage.CALL_ACTION__OPERATION);
		}
		return callAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOccurrence() {
		if (occurrence == null) {
			occurrence = new EObjectWithInverseResolvingEList(CallEvent.class, this, CorePackage.OPERATION__OCCURRENCE, State_machinesPackage.CALL_EVENT__OPERATION);
		}
		return occurrence;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.OPERATION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.OPERATION__NAMESPACE, msgs);
			case CorePackage.OPERATION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.OPERATION__PARAMETER_TEMPLATE, msgs);
			case CorePackage.OPERATION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__OWNER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.OPERATION__OWNER, msgs);
			case CorePackage.OPERATION__PARAMETER:
				return ((InternalEList) getParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__RAISED_SIGNAL:
				return ((InternalEList) getRaisedSignal()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__METHOD:
				return ((InternalEList) getMethod()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__CALL_ACTION:
				return ((InternalEList) getCallAction()).basicAdd(otherEnd, msgs);
			case CorePackage.OPERATION__OCCURRENCE:
				return ((InternalEList) getOccurrence()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.OPERATION__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.OPERATION__NAMESPACE, msgs);
			case CorePackage.OPERATION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CorePackage.OPERATION__PARAMETER_TEMPLATE, msgs);
			case CorePackage.OPERATION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__OWNER:
				return eBasicSetContainer(null, CorePackage.OPERATION__OWNER, msgs);
			case CorePackage.OPERATION__PARAMETER:
				return ((InternalEList) getParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__RAISED_SIGNAL:
				return ((InternalEList) getRaisedSignal()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__METHOD:
				return ((InternalEList) getMethod()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__CALL_ACTION:
				return ((InternalEList) getCallAction()).basicRemove(otherEnd, msgs);
			case CorePackage.OPERATION__OCCURRENCE:
				return ((InternalEList) getOccurrence()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.OPERATION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CorePackage.OPERATION__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case CorePackage.OPERATION__OWNER:
				return eContainer.eInverseRemove(this, CorePackage.CLASSIFIER__FEATURE, Classifier.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.OPERATION__NAME:
			return getName();
		case CorePackage.OPERATION__VISIBILITY:
			return getVisibility();
		case CorePackage.OPERATION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.OPERATION__NAMESPACE:
			return getNamespace();
		case CorePackage.OPERATION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.OPERATION__CONSTRAINT:
			return getConstraint();
		case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.OPERATION__PRESENTATION:
			return getPresentation();
		case CorePackage.OPERATION__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.OPERATION__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.OPERATION__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CorePackage.OPERATION__COMMENT:
			return getComment();
		case CorePackage.OPERATION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.OPERATION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.OPERATION__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CorePackage.OPERATION__STEREOTYPE:
			return getStereotype();
		case CorePackage.OPERATION__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.OPERATION__REFERENCE_TAG:
			return getReferenceTag();
		case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CorePackage.OPERATION__BEHAVIOR:
			return getBehavior();
		case CorePackage.OPERATION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.OPERATION__COLLABORATION:
			return getCollaboration();
		case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CorePackage.OPERATION__PARTITION:
			return getPartition();
		case CorePackage.OPERATION__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.OPERATION__OWNER_SCOPE:
			return getOwnerScope();
		case CorePackage.OPERATION__OWNER:
			return getOwner();
		case CorePackage.OPERATION__IS_QUERY:
			return isIsQuery() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.OPERATION__PARAMETER:
			return getParameter();
		case CorePackage.OPERATION__RAISED_SIGNAL:
			return getRaisedSignal();
		case CorePackage.OPERATION__CONCURRENCY:
			return getConcurrency();
		case CorePackage.OPERATION__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.OPERATION__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.OPERATION__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.OPERATION__SPECIFICATION:
			return getSpecification();
		case CorePackage.OPERATION__METHOD:
			return getMethod();
		case CorePackage.OPERATION__CALL_ACTION:
			return getCallAction();
		case CorePackage.OPERATION__OCCURRENCE:
			return getOccurrence();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.OPERATION__NAME:
			setName((String) newValue);
			return;
		case CorePackage.OPERATION__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CorePackage.OPERATION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.OPERATION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.OPERATION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CorePackage.OPERATION__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__OWNER_SCOPE:
			setOwnerScope((ScopeKind) newValue);
			return;
		case CorePackage.OPERATION__OWNER:
			setOwner((Classifier) newValue);
			return;
		case CorePackage.OPERATION__IS_QUERY:
			setIsQuery(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.OPERATION__PARAMETER:
			getParameter().clear();
			getParameter().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__RAISED_SIGNAL:
			getRaisedSignal().clear();
			getRaisedSignal().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__CONCURRENCY:
			setConcurrency((CallConcurrencyKind) newValue);
			return;
		case CorePackage.OPERATION__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.OPERATION__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.OPERATION__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.OPERATION__SPECIFICATION:
			setSpecification((String) newValue);
			return;
		case CorePackage.OPERATION__METHOD:
			getMethod().clear();
			getMethod().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__CALL_ACTION:
			getCallAction().clear();
			getCallAction().addAll((Collection) newValue);
			return;
		case CorePackage.OPERATION__OCCURRENCE:
			getOccurrence().clear();
			getOccurrence().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.OPERATION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.OPERATION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.OPERATION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.OPERATION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.OPERATION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.OPERATION__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.OPERATION__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.OPERATION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.OPERATION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.OPERATION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CorePackage.OPERATION__COMMENT:
			getComment().clear();
			return;
		case CorePackage.OPERATION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.OPERATION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.OPERATION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CorePackage.OPERATION__STEREOTYPE:
			getStereotype().clear();
			return;
		case CorePackage.OPERATION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.OPERATION__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CorePackage.OPERATION__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.OPERATION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.OPERATION__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CorePackage.OPERATION__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.OPERATION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.OPERATION__OWNER_SCOPE:
			setOwnerScope(OWNER_SCOPE_EDEFAULT);
			return;
		case CorePackage.OPERATION__OWNER:
			setOwner((Classifier) null);
			return;
		case CorePackage.OPERATION__IS_QUERY:
			setIsQuery(IS_QUERY_EDEFAULT);
			return;
		case CorePackage.OPERATION__PARAMETER:
			getParameter().clear();
			return;
		case CorePackage.OPERATION__RAISED_SIGNAL:
			getRaisedSignal().clear();
			return;
		case CorePackage.OPERATION__CONCURRENCY:
			setConcurrency(CONCURRENCY_EDEFAULT);
			return;
		case CorePackage.OPERATION__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CorePackage.OPERATION__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CorePackage.OPERATION__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CorePackage.OPERATION__SPECIFICATION:
			setSpecification(SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.OPERATION__METHOD:
			getMethod().clear();
			return;
		case CorePackage.OPERATION__CALL_ACTION:
			getCallAction().clear();
			return;
		case CorePackage.OPERATION__OCCURRENCE:
			getOccurrence().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.OPERATION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.OPERATION__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CorePackage.OPERATION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.OPERATION__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.OPERATION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.OPERATION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.OPERATION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.OPERATION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.OPERATION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.OPERATION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.OPERATION__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CorePackage.OPERATION__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.OPERATION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.OPERATION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.OPERATION__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CorePackage.OPERATION__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CorePackage.OPERATION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.OPERATION__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CorePackage.OPERATION__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CorePackage.OPERATION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.OPERATION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.OPERATION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.OPERATION__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CorePackage.OPERATION__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.OPERATION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.OPERATION__OWNER_SCOPE:
			return ownerScope != OWNER_SCOPE_EDEFAULT;
		case CorePackage.OPERATION__OWNER:
			return getOwner() != null;
		case CorePackage.OPERATION__IS_QUERY:
			return isQuery != IS_QUERY_EDEFAULT;
		case CorePackage.OPERATION__PARAMETER:
			return parameter != null && !parameter.isEmpty();
		case CorePackage.OPERATION__RAISED_SIGNAL:
			return raisedSignal != null && !raisedSignal.isEmpty();
		case CorePackage.OPERATION__CONCURRENCY:
			return concurrency != CONCURRENCY_EDEFAULT;
		case CorePackage.OPERATION__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CorePackage.OPERATION__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CorePackage.OPERATION__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CorePackage.OPERATION__SPECIFICATION:
			return SPECIFICATION_EDEFAULT == null ? specification != null : !SPECIFICATION_EDEFAULT.equals(specification);
		case CorePackage.OPERATION__METHOD:
			return method != null && !method.isEmpty();
		case CorePackage.OPERATION__CALL_ACTION:
			return callAction != null && !callAction.isEmpty();
		case CorePackage.OPERATION__OCCURRENCE:
			return occurrence != null && !occurrence.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (concurrency: "); //$NON-NLS-1$
		result.append(concurrency);
		result.append(", isRoot: "); //$NON-NLS-1$
		result.append(isRoot);
		result.append(", isLeaf: "); //$NON-NLS-1$
		result.append(isLeaf);
		result.append(", isAbstract: "); //$NON-NLS-1$
		result.append(isAbstract);
		result.append(", specification: "); //$NON-NLS-1$
		result.append(specification);
		result.append(')');
		return result.toString();
	}

} // OperationImpl
